/* -*- Mode: C ; c-basic-offset: 2 -*- */
/*
 * LADI Session Handler (ladish)
 *
 * Copyright (C) 2010 Nedko Arnaudov <nedko@arnaudov.name>
 *
 **************************************************************************
 * This file contains interface to code for sending notifications to user
 **************************************************************************
 *
 * LADI Session Handler is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * LADI Session Handler is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with LADI Session Handler. If not, see <http://www.gnu.org/licenses/>
 * or write to the Free Software Foundation, Inc.,
 * 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef NOTIFY_PROXY_H__9C284CDE_3AC0_4F3E_A2C3_10ADF2CBDE46__INCLUDED
#define NOTIFY_PROXY_H__9C284CDE_3AC0_4F3E_A2C3_10ADF2CBDE46__INCLUDED

#include "common.h"

#define LADISH_NOTIFY_URGENCY_LOW    0
#define LADISH_NOTIFY_URGENCY_NORMAL 1
#define LADISH_NOTIFY_URGENCY_HIGH   2

bool ladish_notify_init(const char * app_name);
void ladish_notify_uninit(void);
void ladish_notify_simple(uint8_t urgency, const char * summary, const char * body); /* body can be NULL */

#endif /* #ifndef NOTIFY_PROXY_H__9C284CDE_3AC0_4F3E_A2C3_10ADF2CBDE46__INCLUDED */
